// KURUMA Keizo:2011. thank you for your attention.
// 何かの役に立つなら "modified BSD license" か "X11 license" でご自由にどうぞ

function Clone(dst, src) {
	for( m in src )
		dst[m] = src[m];
}


var qt = 16; //クオンタイズっていうかスクリーン座標変換の係数

var keyst = {
	l:false
	,r:false
	,u:false
	,d:false
	,b1:false
	,b2:false
	,b3:false
	,b4:false
}


///////////////////////

var actor = {
	status:0
	,anim_dir:1
	,anim_num:0
	,anim_num_i:0
	,x:512/4*qt
	,y:(300-48)*qt
	,vx:0
	,vy:0

	, //初期化
	init:function() {
		this.status = 0;
		this.anim_dir = 1;
		this.anim_num = 0;
		this.anim_num_i = 0;
		this.x = 512/4*qt;
		this.y = (300-48)*qt;
		this.vx = 0;
		this.vy = 0;
	}

	,
	reinit:function() {
		this.init();
	}

	, //つぶれ
	splash:function() {
		//if( keyst.b3 ) return; //無敵

		this.status = 1;
		//view.stop();
	}

	, //人間移動
	move:function() {

		//つぶれたら動かない
		if( this.status != 0 ) {
			if( keyst.b4 ) {
				btnRestartOnClick();
			}
		}

		//キーに応じてキャラ移動
		ix = 0;
		iy = 0;

		d = 2 * qt;
		dbreak = 3 * qt;
		djump = 24 * qt;
		grav = 4*qt;

		vmax = 16 * qt
		vymax = 24 * qt
		eps = 1;

		act_xmin = -48 * qt;
		act_xmax = 512 * qt;

		act_ymax = (300-48) * qt;

		//動く意図
		if( this.status == 0 ) {
			if( keyst.l ) ix -= d;
			if( keyst.r ) ix += d;
			//if( keyst.u ) iy -= d;
			//if( keyst.d ) iy += d;

			//斜めの場合、力をsin(45)化
			//if( ix != 0 && iy != 0 ) {
			//	ix = Math.floor(ix * .85);
			//	iy = Math.floor(iy * .85);
			//}

			//jump
			if( keyst.b1 && act_ymax <= this.y ) this.vy = -djump;
		}

		//X どちらかへ進む場合
		if( ix <= -eps || eps < ix ) {
			this.vx += ix;
		}
		else { //ブレーキ
			if     (this.vx <= -eps) this.vx += Math.min(dbreak, -this.vx);
			else if(eps <= this.vx ) this.vx -= Math.min(dbreak, this.vx);
		}
		//Y どちらかへ進む場合
		//if( iy <= -eps || eps < iy ) {
		//	this.vy += iy;
		//}
		//else { //ブレーキ
		//	if     (this.vy <= -eps) this.vy += Math.min(dbreak, -this.vy);
		//	else if(eps <= this.vy ) this.vy -= Math.min(dbreak, this.vy);
		//}

		//重力
		this.vy += grav;

		//X速度上限
		if(-eps < this.vx && this.vx < eps) this.vx = 0;
		else if( this.vx < -vmax ) this.vx = -vmax;
		else if( vmax < this.vx  ) this.vx = vmax;

		//Y速度上限
		if(-eps < this.vy && this.vy < eps) this.vy = 0;
		else if( this.vy < -vymax ) this.vy = -vymax;
		else if( vymax < this.vy  ) this.vy = vymax;

		// 斜めの場合...
		//if( this.vx != 0 && this.vy != 0 ) {
		//  this.vx *= .85;
		//  this.vy *= .85;
		//}


		//位置変更
		this.x += this.vx;
		this.y += this.vy;

		//位置上限下限X
		if     ( this.x < act_xmin ) this.x = act_xmax;
		else if( act_xmax < this.x ) this.x = act_xmin;

		//位置上限下限Y
		if     ( this.y < 0        ) this.y = 0;
		else if( act_ymax < this.y ) this.y = act_ymax;


		//アニメーション
		if( this.y < act_ymax -eps ) { //浮いてる
			this.anim_dir = (this.vx < 0)? 0: 1;
			this.anim_num = 1;
		}
		else if( -eps < this.vx && this.vx < eps ) { //止まってる
			this.anim_num = 0;
			this.anim_num_i = 0;
		}
		else { //歩き
			this.anim_dir = (this.vx < 0)? 0: 1;
			this.anim_num_i = (this.anim_num_i + 1) % (3*2);
			this.anim_num = 1 + Math.floor(this.anim_num_i / 2);
		}

	}
}


function Ball(id_) {
	Clone(this, Ball_proto);
	this.color = id_ % 8;
}
var Ball_proto = {
	x:0, y:0, vx:0, vy:0, color:0
	,
	init:function() {
		this.x = (512-48)*qt;
		this.y = (300-48)*qt;
		this.vx = 0;
		this.vy = 0;
		this.initVxVy();
	}
	,
	initVxVy:function() {
		vx = Math.floor(Math.random() * 10*qt) + 5*qt;
		this.vx = (this.vx <= 0)? -vx: +vx;
		this.vy = -(Math.floor(Math.random() * 20*qt) + 40*qt);
	}

	, //ボール移動
	move:function() {

		grav = 4*qt;
		ball_xmin = -48 * qt;
		ball_xmax = 512 * qt;

		ball_ymax = (300-48) * qt;


		//重力
		this.vy += grav;


		this.x += this.vx;
		this.y += this.vy;

		//位置上限下限X
		if     ( this.x < ball_xmin ) { // 左の壁
			this.vx = -this.vx;
			this.x = ball_xmin + ball_xmin - this.x;
		}
		else if( ball_xmax < this.x ) { // 右の壁
			this.vx = -this.vx;
			this.x = ball_xmax + ball_xmax - this.x;
			
			if( actor.status == 0 ) {
				model.addBall();
				model.score += 300;
			}
		}

		//位置上限下限Y
		if     ( this.y < 0        ) {
			this.vy = 0;
			this.y = 0;
		}
		else if( ball_ymax < this.y ) {
			if( actor.status == 0 )
				model.score += 10;

			this.vy = -this.vy * 0.98;

			//this.y = ball_ymax + ball_ymax - this.y;
			this.y = ball_ymax;

			if( Math.abs(this.vy) < 20*qt ) {
				this.initVxVy();
				if( actor.status == 0 )
					model.score += 100;
			}

		}
	}
}


var model = {
	score:0
	,timerid:null
	,ball_cnt:0
	,ball_max:16
	,balls:null

	, //初期化
	init:function() {
		try {
			actor.init();
			//ball.init();

			this.balls = new Array(this.ball_max);

			for( i = 0; i < this.ball_max; i++ ) {
				this.balls[i] = new Ball(i);
			}
			this.addBall();

		} catch(ex) {
			alert(ex);
		}
	}

	,
	reinit:function() {
		this.score = 0;
		this.ball_cnt = 0;
		this.addBall();
		actor.reinit();
	}

	, //ボール追加
	addBall:function() {
		if( this.ball_cnt < this.ball_max ) {
			//this.balls[this.ball_cnt] = new Ball(this.ball_cnt);
			this.balls[this.ball_cnt].init();
			this.ball_cnt += 1;
		}
	}

	, //移動
	move:function() {
		actor.move();

		for( i = 0; i < this.ball_cnt; i++ ) {
			this.balls[i].move();
		}

		this.colicheck();
	}

	, //衝突チェック
	colicheck:function() {
		
		for( i = 0; i < this.ball_cnt; i++ ) {
			
			//位置が近い
			if( Math.abs(this.balls[i].x - actor.x) < 24*qt
				&& Math.abs(this.balls[i].y - actor.y) < 24*qt ) {
			
				//ボールが下降中
				if( 0 < this.balls[i].vy ) {

					actor.splash();
					view.debug.value = "hit";

				}
			}
		}
	}

	,
	start:function()
	{
		if( this.timerid == null )
			this.timerid = setInterval(this.onTimer, 34);
	}

	,
	stop:function()
	{
		clearTimeout(this.timerid);
		this.timerid = null;
	}

	,
	onTimer:function()
	{
		//view.debug.value = view.debug.value + "|";
		//移動
		model.move();
		//描画
		view.draw();
	}
}

////////////////////////

var view = {
	canvas:null
	,context:null
	,img_actor:null
	,img_actor_x:null
	,img_ball:null
	,balls:null
	,score:null
	,debug:null

	,
	init:function() {
		this.canvas = document.getElementById("canvas0");
		this.context = this.canvas.getContext("2d");
		this.img_actor_x = document.getElementById("actor_x");
		this.img_actor = new Array(8);
		this.img_actor[0] = document.getElementById("actorL0");
		this.img_actor[1] = document.getElementById("actorL1");
		this.img_actor[2] = document.getElementById("actorL2");
		this.img_actor[3] = document.getElementById("actorL3");
		this.img_actor[4] = document.getElementById("actorR0");
		this.img_actor[5] = document.getElementById("actorR1");
		this.img_actor[6] = document.getElementById("actorR2");
		this.img_actor[7] = document.getElementById("actorR3");

		this.img_ball = new Array(8);
		this.img_ball[0] = document.getElementById("ball0");
		this.img_ball[1] = document.getElementById("ball1");
		this.img_ball[2] = document.getElementById("ball2");
		this.img_ball[3] = document.getElementById("ball3");
		this.img_ball[4] = document.getElementById("ball4");
		this.img_ball[5] = document.getElementById("ball5");
		this.img_ball[6] = document.getElementById("ball6");
		this.img_ball[7] = document.getElementById("ball7");

		this.balls = document.getElementById("balls");
		this.score = document.getElementById("score");

		this.debug = document.getElementById("debug");
	}

	,
	draw:function() {
		view.context.clearRect(0, 0, 512, 300);


		if( actor.status == 0 ) {
			anim_num = actor.anim_dir * 4 + actor.anim_num;
			img = view.img_actor[anim_num];
			view.context.drawImage(img, actor.x / qt, actor.y / qt);
		}
		else {
			view.context.drawImage(view.img_actor_x, actor.x / qt, actor.y / qt);
		}

		for( i = 0; i < model.ball_cnt; i++ ) {
			color = model.balls[i].color;
			view.context.drawImage(
				view.img_ball[color], model.balls[i].x / qt, model.balls[i].y / qt);
		}

		this.balls.value = model.ball_cnt;
		this.score.value = model.score;
	}

}

// user control

function keyCode(e)
{
	if(document.all)
		return e.keyCode;
	if(document.getElementById)
		return (e.keyCode)? e.keyCode: e.charCode;
	if(document.layers)
		return e.which;
	return 0;
}

document.onkeydown = function(e)
{
	view.debug.value = "down";
	try {
		rc = false;
		k = keyCode(e);
		if     ( k == 37 ) keyst.l = true;
		else if( k == 39 ) keyst.r = true;
		else if( k == 38 ) keyst.u = true;
		else if( k == 40 ) keyst.d = true;
		else if( k == 32/*spc*/ ) keyst.b1 = true;
		else if( k == 90/*z*/ ) keyst.b1 = true;
		else if( k == 88/*x*/ ) keyst.b2 = true;
		else if( k == 67/*c*/ ) keyst.b3 = true;
		else if( k == 13/*ent*/ ) keyst.b4 = true;

		else if( 112 <= k && k <= 123 ) rc = true;/*F1-F12*/
	}
	catch(ex) {
		alert(ex);
	}
	return rc;
}

document.onkeyup = function(e)
{
	view.debug.value = "up";
	try {
		rc = false;
		k = keyCode(e);

		if     ( k == 37 ) keyst.l = false;
		else if( k == 39 ) keyst.r = false;
		else if( k == 38 ) keyst.u = false;
		else if( k == 40 ) keyst.d = false;
		else if( k == 32/*spc*/ ) keyst.b1 = false;
		else if( k == 90/*z*/ ) keyst.b1 = false;
		else if( k == 88/*x*/ ) keyst.b2 = false;
		else if( k == 67/*c*/ ) keyst.b3 = false;
		else if( k == 13/*ent*/ ) keyst.b4 = false;

		else if( 112 <= k && k <= 123 ) rc = true;/*F1-F12*/
	}
	catch(ex) {
		alert(ex);
	}
	return rc;
}

document.onkeypress = function(e)
{
	rc = false;
	k = keyCode(e);
	if( 112 <= k && k <= 123 ) rc = true;/*F1-F12*/
	return rc;
}

function btnAOnClick()
{
}

function btnBOnClick()
{
}

function btnRunOnClick()
{
	model.start();
}

function btnStopOnClick()
{
	model.stop();
}

function btnRestartOnClick()
{
	model.reinit();
	view.draw();
	model.start();
}


/////////////////////////////////////////

function initAll() {
	model.init();
	view.init();
	view.draw();
	model.start();
}

// Local Variables:
// mode:javascript
// tab-width:4
// End:
